{
  TWAIN Integration Kit
  Delphi Sample Program 3.0
  This is a code sample of the TWAIN Integration Kit
  (C) 1995, 1996 by JUNGCLAUS SOFTWARE ENGINEERING

  This sample was developed under Delphi 2.0. It can be
  also converted easy to Delphi 1.0

  All funtions used in this sample are included in the
  Standard Edition of the TIK 2.0
}

unit Unit1;

interface

uses
  WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Clipbrd, About, Menus;

function SelectSourceHighLevel( h : HWnd ) : integer; far; stdcall;
function AcquireNative2Clipboard( h : HWnd ) : integer; far; stdcall;
function ShowSourceDialog(b : Boolean ) : integer; far; stdcall;
function TIK_SetAN2CColorDepth(d : integer ) : integer; far; stdcall;
function TIK_HLAcquire2File(h : HWnd; Filename: String; a : integer; b : integer ) : integer; far; stdcall;
function TIK_ShowInternalErrorMessages( h : HWnd; b : Boolean ) : integer; far; stdcall;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Image1: TImage;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    GroupBox1: TGroupBox;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  StretchImage: Boolean;
  ShowUI: Boolean;
  DetailView: TForm;

implementation

{$R *.DFM}

uses ViewWin, SysUtils;

function SelectSourceHighLevel( h : HWnd ) : integer; external {$ifdef WIN32}'TIK32S'{$else} 'JSETWAIN'{$endif};
function AcquireNative2Clipboard( h : HWnd ) : integer; external 'TIK32S';
function ShowSourceDialog( b : Boolean ) : integer; external 'TIK32S';
function TIK_SetAN2CColorDepth(d : integer ) : integer; external 'TIK32S';
function TIK_HLAcquire2File(h : HWnd; Filename : String; a : integer; b: integer ) : integer; external 'TIK32S';
function TIK_ShowInternalErrorMessages( h : HWnd; b : Boolean ) : integer; external 'TIK32S';


procedure TForm1.FormCreate(Sender: TObject);
begin
    ComboBox1.ItemIndex := 0;
    ComboBox2.ItemIndex := 0;
    ShowUI:=TRUE;
end;


procedure TForm1.BitBtn2Click(Sender: TObject);
begin
     if ShowUI=FALSE then
         ShowSourceDialog(FALSE)
     else
         ShowSourceDialog(TRUE);

     if ComboBox2.ItemIndex=1 then begin
     { Scan via clibboard into this program }

     { supress TIK error messages in case of no valid bitmap given by source }
     TIK_ShowInternalErrorMessages(Handle, FALSE);

     { setup bit depth reduction: no / 256 / 16 }
     if ComboBox1.ItemIndex=1 then
        TIK_SetAN2CColorDepth(256)
     else if ComboBox1.ItemIndex=2 then
        TIK_SetAN2CColorDepth(16);
     AcquireNative2Clipboard(Handle);
     if Clipboard.HasFormat(CF_Bitmap) then begin
         Image1.Picture.Assign(Clipboard);
         Label1.Caption := 'Size: ' + Format(' %d x %d pixel', [Image1.Picture.Height, Image1.Picture.Width]);
     end;

     end

  else begin
       { scan via temp file into this program }
       TIK_HLAcquire2File(Handle, 'DELTWAIN.BMP', 0, 0);
       Image1.Picture.LoadFromFile('DELTWAIN.BMP');
       DeleteFile('DELTWAIN.BMP');
       Label1.Caption := 'Size: ' + Format(' %d x %d pixel', [Image1.Picture.Height, Image1.Picture.Width]);

  end;
end;


procedure TForm1.BitBtn3Click(Sender: TObject);
begin
     { call dialog to select TWAIN data source }
     SelectSourceHighLevel(Handle);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     Image1.Stretch := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     ShowUI := not ShowUI;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
     DetailView:=TAboutBox.Create(Self);
     DetailView.ShowModal;
end;


procedure TForm1.BitBtn5Click(Sender: TObject);
begin
     OpenDialog1.Execute;
     Image1.Picture.LoadFromFile(OpenDialog1.Filename);
     Label1.Caption := 'Size: ' + Format(' %d x %d pixel', [Image1.Picture.Height, Image1.Picture.Width]);
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
  ViewForm.Image1.Picture := Image1.Picture;
  ViewForm.HorzScrollBar.Range := Image1.Picture.Width;
  ViewForm.VertScrollBar.Range := Image1.Picture.Height;
  ViewForm.Caption := 'TIK sample';
  ViewForm.Show;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
     SaveDialog1.Execute;
     Image1.Picture.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     if Clipboard.HasFormat(CF_Bitmap) then begin
         Image1.Picture.Assign(Clipboard);
         Label1.Caption := 'Size: ' + Format(' %d x %d pixel', [Image1.Picture.Height, Image1.Picture.Width]);
         end;
end;

end.

